public class Car
{
	private int yearOfMake;
	private Engine theEngine;

	public Car(int year, Engine e)
	{
		yearOfMake = year;
		theEngine = e;		
	}

	// Applying the same logic as in Engine,
	// we will remove copy constructor for Car and
	// implement a clone.
	public Car(Car other)
	{
		yearOfMake = other.yearOfMake;

		// Deep copy of Engine needed.
		try
		{
			theEngine = (Engine) other.theEngine.clone();
		}
		catch(CloneNotSupportedException ex)
		{
			// Code to propogate or report exception not shown
		}
	}

	public String toString()
	{
		return super.toString() + " : " + yearOfMake + " : " + theEngine.toString();
	}
}